# Base git commit: 29b4817d4018
# (Linux 4.8-rc1)
# 
# Author:    Russell King (Mon 29 Feb 11:30:52 GMT 2016)
# Committer: Russell King (Mon  8 Aug 15:59:52 BST 2016)
# 
#   PCI: mvebu: extend PCIe reset duration
# 
#   Some PCIe cards (such as ASM1062 based SATA cards) appear to need a
#   slightly longer delay between reset being released and the first card
#   access.  Increase the default delay from 20ms to 30ms.
# 
#   Signed-off-by: Russell King
# 
#   52d3df49cd0f49eb0cbd284ac525dbe9c94f7192
#    drivers/pci/host/pci-mvebu.c | 2 +-
#    1 file changed, 1 insertion(+), 1 deletion(-)
# 
# Author:    Russell King (Mon 14 Sep 10:14:57 BST 2015)
# Committer: Russell King (Mon  8 Aug 15:59:51 BST 2016)
# 
#   sfp: removal of defs
# 
#   dac7d2d5840bb7358fc1988a2ea62186f80cbd63
#    include/linux/sfp.h | 32 --------------------------------
#    1 file changed, 32 deletions(-)
# 
# Author:    Russell King (Thu 10 Sep 15:01:44 BST 2015)
# Committer: Russell King (Mon  8 Aug 15:59:50 BST 2016)
# 
#   implement slot capabilities (SSPL)
# 
#   995fd7ed2340b924c63ba17ffee98acdef14ccfc
#    drivers/pci/host/pci-mvebu.c | 22 ++++++++++++++++++++--
#    1 file changed, 20 insertions(+), 2 deletions(-)
# 
# Author:    Russell King (Sun  6 Sep 23:45:17 BST 2015)
# Committer: Russell King (Mon  8 Aug 15:59:50 BST 2016)
# 
#   mvebu/clearfog updates
# 
#   Signed-off-by: Russell King
# 
#   ce722aa824847b5dbdba3ff32508b08e1060f6d5
#    arch/arm/boot/dts/armada-388-clearfog.dts |  36 +++++-----
#    drivers/pci/host/pci-mvebu.c              | 109 ++++++++++++++++++++++++++++--
#    drivers/pci/pcie/aspm.c                   |   2 +
#    drivers/pci/pcie/portdrv_core.c           |   2 +
#    4 files changed, 126 insertions(+), 23 deletions(-)
# 
# Author:    Russell King (Fri 28 Aug 19:15:51 BST 2015)
# Committer: Russell King (Mon  8 Aug 15:59:49 BST 2016)
# 
#   ARM: dts: Add Clearfog A1 rev 2.0 DT file
# 
#   Signed-off-by: Russell King
# 
#   d91fadfe16744fdc64168cce4582b8db8135b987
#    arch/arm/boot/dts/armada-388-clearfog.dts | 50 +++++++++++++++++++++++++++++++
#    1 file changed, 50 insertions(+)
# 
# Author:    Russell King (Sat 12 Sep 18:43:39 BST 2015)
# Committer: Russell King (Mon  8 Aug 15:59:48 BST 2016)
# 
#   ARM: dts: armada388-clearfog: add SFP module support
# 
#   Add SFP module support for Clearfog using the SFP phylink support.
# 
#   Signed-off-by: Russell King
# 
#   a482b0695d267b70afb80dfbbfe756a6720d39e0
#    arch/arm/boot/dts/armada-388-clearfog.dts | 44 ++++++++-----------------------
#    1 file changed, 11 insertions(+), 33 deletions(-)
# 
# Author:    Russell King (Mon  4 Jul 10:17:28 BST 2016)
# Committer: Russell King (Mon  8 Aug 15:59:48 BST 2016)
# 
#   ARM: dts: armada388-clearfog: number LAN ports properly
# 
#   Currently, the ports as seen from the rear number as:
# 
#   	eth0 sfp lan5 lan4 lan3 lan2 lan1 lan6
# 
#   which is illogical - this came about because the rev 2.0 boards have the
#   LEDs on the front for the DSA switch (lan5-1) reversed.  Rev 2.1 boards
#   fixed the LED issue, and the Clearfog case numbers the lan ports
#   increasing from left to right.
# 
#   Maintaining this illogical numbering causes confusion, with reports that
#   "my link isn't coming up" and "my connection negotiates 10base-Half"
#   both of which are due to people thinking that the port next to the SFP
#   is lan1.
# 
#   Fix this by renumbering the ports to match people's expectations.
# 
#   Signed-off-by: Russell King
# 
#   aa0a9c273b6a356ea932ac9bbcbbff204677995d
#    arch/arm/boot/dts/armada-388-clearfog.dts | 8 ++++----
#    1 file changed, 4 insertions(+), 4 deletions(-)
# 
# Author:    Russell King (Mon  8 Aug 15:59:46 BST 2016)
# Committer: Russell King (Mon  8 Aug 15:59:46 BST 2016)
# 
#   Merge branches 'mvebu-cpuidle' and 'phy' into clearfog
# 
# Author:    Russell King (Tue 12 Jul 16:45:43 BST 2016)
# Committer: Russell King (Mon  8 Aug 15:58:31 BST 2016)
# 
#   phy: marvell: 88E1540: add flow control support
# 
#   The Marvell PHYs support pause frame advertisments, so we should not be
#   masking their support off.  Add the necessary flag to the Marvell PHY
#   to allow any MAC level pause frame support to be advertised.
# 
#   Signed-off-by: Russell King
# 
#   39341dbf4dc156a923f75e5dbde33d74accc0d3b
#    drivers/net/phy/marvell.c | 2 +-
#    1 file changed, 1 insertion(+), 1 deletion(-)
# 
# Author:    Russell King (Tue 12 Jul 16:45:43 BST 2016)
# Committer: Russell King (Mon  8 Aug 15:58:31 BST 2016)
# 
#   phy: marvell: 88E1111: add flow control support
# 
#   The Marvell PHYs support pause frame advertisments, so we should not be
#   masking their support off.  Add the necessary flag to the Marvell PHY
#   to allow any MAC level pause frame support to be advertised.
# 
#   Signed-off-by: Russell King
# 
#   9cddd36dff8a031f65927eead0656ff7889d2d71
#    drivers/net/phy/marvell.c | 2 +-
#    1 file changed, 1 insertion(+), 1 deletion(-)
# 
# Author:    Russell King (Thu  1 Oct 00:34:08 BST 2015)
# Committer: Russell King (Mon  8 Aug 15:58:31 BST 2016)
# 
#   phy: marvell: 88E1512: add flow control support
# 
#   The Marvell PHYs support pause frame advertisments, so we should not be
#   masking their support off.  Add the necessary flag to the Marvell PHY
#   to allow any MAC level pause frame support to be advertised.
# 
#   Reviewed-by: Florian Fainelli
#   Signed-off-by: Russell King
# 
#   6b9c6f617465627c247a0eaff562dd7eec01d351
#    drivers/net/phy/marvell.c | 3 ++-
#    1 file changed, 2 insertions(+), 1 deletion(-)
# 
# Author:    Russell King (Thu  8 Oct 23:49:47 BST 2015)
# Committer: Russell King (Mon  8 Aug 15:58:30 BST 2016)
# 
#   sfp/phylink: hook up eeprom functions
# 
#   Signed-off-by: Russell King
# 
#   ad99c50223c78e12c81d794b310c700922ba8363
#    drivers/net/phy/sfp.c | 19 +++++++++++--------
#    1 file changed, 11 insertions(+), 8 deletions(-)
# 
# Author:    Russell King (Thu  1 Oct 23:32:39 BST 2015)
# Committer: Russell King (Mon  8 Aug 15:58:30 BST 2016)
# 
#   net: mvneta: add module EEPROM reading support
# 
#   Signed-off-by: Russell King
# 
#   396d53b687bac6284537896613d2bf4a9c571479
#    drivers/net/ethernet/marvell/mvneta.c | 18 ++++++++++++++++++
#    1 file changed, 18 insertions(+)
# 
# Author:    Russell King (Thu  1 Oct 23:10:05 BST 2015)
# Committer: Russell King (Mon  8 Aug 15:58:30 BST 2016)
# 
#   phylink: add module EEPROM support
# 
#   Add support for reading module EEPROMs through phylink.
# 
#   Reviewed-by: Florian Fainelli
#   Signed-off-by: Russell King
# 
#   0c3477cbca12b91f35ffc3f76ebd7705b6aaa9e9
#    drivers/net/phy/phylink.c | 66 +++++++++++++++++++++++++++++++++++++++++++++++
#    include/linux/phylink.h   | 12 +++++++++
#    2 files changed, 78 insertions(+)
# 
# Author:    Russell King (Tue 29 Sep 15:17:39 BST 2015)
# Committer: Russell King (Mon  8 Aug 15:58:30 BST 2016)
# 
#   net: mvneta: add EEE support
# 
#   Add EEE support to mvneta.  This allows us to enable the low power idle
#   support at MAC level if there is a PHY attached through phylink which
#   supports LPI.  The appropriate ethtool support is provided to allow the
#   feature to be controlled, including ethtool statistics for EEE wakeup
#   errors.
# 
#   Signed-off-by: Russell King
# 
#   e6e6a99e0a839859c8649bc89115fd754f8651d8
#    drivers/net/ethernet/marvell/mvneta.c | 87 +++++++++++++++++++++++++++++++++++
#    1 file changed, 87 insertions(+)
# 
# Author:    Russell King (Thu  1 Oct 21:19:53 BST 2015)
# Committer: Russell King (Mon  8 Aug 15:58:29 BST 2016)
# 
#   phylink: add EEE support
# 
#   Add EEE hooks to phylink to allow the phylib EEE functions for the
#   connected phy to be safely accessed.
# 
#   Signed-off-by: Russell King
# 
#   ecbb95bca1550297c84407da7c0b61333d861b39
#    drivers/net/phy/phylink.c | 58 ++++++++++++++++++++++++++++++++++++++++++++++-
#    include/linux/phylink.h   |  7 +++++-
#    2 files changed, 63 insertions(+), 2 deletions(-)
# 
# Author:    Russell King (Tue 12 Jul 00:04:13 BST 2016)
# Committer: Russell King (Mon  8 Aug 15:58:29 BST 2016)
# 
#   net: mvneta: enable flow control for fixed connections
# 
#   Allow symetric flow control to be enabled for fixed link connections as
#   well as other types of connections by setting the supported and
#   advertised capability bits.
# 
#   Signed-off-by: Russell King
# 
#   0e5bc6e10ac488f152c2f458d9fd5b2a6ca76416
#    drivers/net/ethernet/marvell/mvneta.c | 11 +++++++----
#    1 file changed, 7 insertions(+), 4 deletions(-)
# 
# Author:    Russell King (Thu  1 Oct 00:34:08 BST 2015)
# Committer: Russell King (Mon  8 Aug 15:58:29 BST 2016)
# 
#   net: mvneta: enable flow control for PHY connections
# 
#   Enable flow control support for PHY connections by indicating our
#   support via the ethtool capabilities.  phylink takes care of the
#   appropriate handling.
# 
#   Reviewed-by: Florian Fainelli
#   Signed-off-by: Russell King
# 
#   be33da37b6087ff0b50f222b48e6c293e19316a7
#    drivers/net/ethernet/marvell/mvneta.c | 2 ++
#    1 file changed, 2 insertions(+)
# 
# Author:    Russell King (Thu  1 Oct 17:41:44 BST 2015)
# Committer: Russell King (Mon  8 Aug 15:58:29 BST 2016)
# 
#   net: mvneta: add flow control support via phylink
# 
#   Add flow control support to mvneta, including the ethtool hooks.  This
#   uses the phylink code to calculate the result of autonegotiation where
#   a phy is attached, and to handle the ethtool settings.
# 
#   Signed-off-by: Russell King
# 
#   5974cf0d112fedf9ef724b3e411fb2b880bedb1b
#    drivers/net/ethernet/marvell/mvneta.c | 28 +++++++++++++++++++++++++++-
#    1 file changed, 27 insertions(+), 1 deletion(-)
# 
# Author:    Russell King (Thu  1 Oct 20:32:07 BST 2015)
# Committer: Russell King (Mon  8 Aug 15:58:28 BST 2016)
# 
#   phylink: add flow control support
# 
#   Add flow control support, including ethtool support, to phylink.  We
#   add support to allow ethtool to get and set the current flow control
#   settings, and the 802.3 specified resolution for the local and remote
#   link partner abilities.
# 
#   Signed-off-by: Russell King
# 
#   4272a0b14d30d711701641d4cfc2c7041ad43e02
#    drivers/net/phy/phylink.c | 133 +++++++++++++++++++++++++++++++++++++++++++++-
#    include/linux/phylink.h   |   8 +++
#    2 files changed, 139 insertions(+), 2 deletions(-)
# 
# Author:    Russell King (Thu  1 Oct 19:40:31 BST 2015)
# Committer: Russell King (Mon  8 Aug 15:58:28 BST 2016)
# 
#   net: mvneta: add nway_reset support
# 
#   Add ethtool nway_reset support to mvneta via phylink, so that userspace
#   can request the link in whatever mode to be renegotiated via
#   ethtool -r ethX.
# 
#   Signed-off-by: Russell King
# 
#   27d017bec8f3408fa4399ebff0fe6c69a953e695
#    drivers/net/ethernet/marvell/mvneta.c | 8 ++++++++
#    1 file changed, 8 insertions(+)
# 
# Author:    Russell King (Thu  1 Oct 20:27:19 BST 2015)
# Committer: Russell King (Mon  8 Aug 15:58:28 BST 2016)
# 
#   phylink: add ethtool nway_reset support
# 
#   Add ethtool nway_reset support to phylink, to allow userspace to
#   request a re-negotiation of the link.
# 
#   Reviewed-by: Florian Fainelli
#   Signed-off-by: Russell King
# 
#   0c6a9fa59812af907b99afb3fd10e932b69880e8
#    drivers/net/phy/phylink.c | 14 ++++++++++++++
#    include/linux/phylink.h   |  1 +
#    2 files changed, 15 insertions(+)
# 
# Author:    Russell King (Fri  2 Oct 22:46:54 BST 2015)
# Committer: Russell King (Mon  8 Aug 15:58:28 BST 2016)
# 
#   phy: fixed-phy: remove fixed_phy_update_state()
# 
#   mvneta is the only user of fixed_phy_update_state(), which has been
#   converted to use phylink instead.  Remove fixed_phy_update_state().
# 
#   Reviewed-by: Florian Fainelli
#   Signed-off-by: Russell King
# 
#   70796de7a4f8d35d37c1e0ed0558498392e35688
#    drivers/net/phy/fixed_phy.c | 31 -------------------------------
#    include/linux/phy_fixed.h   |  9 ---------
#    2 files changed, 40 deletions(-)
# 
# Author:    Russell King (Wed 16 Sep 21:27:10 BST 2015)
# Committer: Russell King (Mon  8 Aug 15:58:27 BST 2016)
# 
#   net: mvneta: convert to phylink
# 
#   Convert mvneta to use phylink, which models the MAC to PHY link in
#   a generic, reusable form.
# 
#   Signed-off-by: Russell King
# 
#   c4881310fe37eb07ddc804a55cf865450f5b2c40
#    drivers/net/ethernet/marvell/Kconfig  |   2 +-
#    drivers/net/ethernet/marvell/mvneta.c | 455 +++++++++++++++++-----------------
#    2 files changed, 226 insertions(+), 231 deletions(-)
# 
# Author:    Russell King (Sun 13 Sep 01:06:31 BST 2015)
# Committer: Russell King (Mon  8 Aug 15:58:27 BST 2016)
# 
#   sfp: display SFP module information
# 
#   Signed-off-by: Russell King
# 
#   fe17c5959d02b194986ab8070b1691c50bf9ff85
#    drivers/net/phy/sfp.c | 247 +++++++++++++++++++++++++++++++++++++++++++++++++-
#    1 file changed, 246 insertions(+), 1 deletion(-)
# 
# Author:    Russell King (Sat 12 Sep 18:43:39 BST 2015)
# Committer: Russell King (Mon  8 Aug 15:58:27 BST 2016)
# 
#   sfp: add phylink based SFP module support
# 
#   Add support for SFP hotpluggable modules via phylink.  This supports
#   both copper and optical SFP modules, which require different Serdes
#   modes in order to properly negotiate the link.
# 
#   Optical SFP modules typically require the Serdes link to be talking
#   1000base-X mode - this is the gigabit ethernet mode defined by the
#   802.3 standard.
# 
#   Copper SFP modules typically integrate a PHY in the module to convert
#   from Serdes to copper, and the PHY will be configured by the vendor
#   to either present a 1000base-X Serdes link (for fixed 1000base-T) or
#   a SGMII Serdes link.  However, this is vendor defined, so we instead
#   detect the PHY, switch the link to SGMII mode, and use traditional
#   PHY based negotiation.
# 
#   Signed-off-by: Russell King
# 
#   0d3524af8bceb1d2b13b3179960d23fe1c1cbc66
#    drivers/net/phy/Kconfig  |   5 +
#    drivers/net/phy/Makefile |   1 +
#    drivers/net/phy/sfp.c    | 986 +++++++++++++++++++++++++++++++++++++++++++++++
#    include/linux/sfp.h      | 339 ++++++++++++++++
#    4 files changed, 1331 insertions(+)
#    create mode 100644 drivers/net/phy/sfp.c
#    create mode 100644 include/linux/sfp.h
# 
# Author:    Russell King (Thu 24 Sep 11:01:13 BST 2015)
# Committer: Russell King (Mon  8 Aug 15:58:27 BST 2016)
# 
#   phylink: add hooks for SFP support
# 
#   Add support to phylink for SFP, which needs to control and configure
#   the ethernet MAC link state.  Specifically, SFP needs to:
# 
#   1. set the negotiation mode between SGMII and 1000base-X
#   2. attach and detach the module PHY
#   3. prevent the link coming up when errors are reported
# 
#   In the absence of a PHY, we also need to set the ethtool port type
#   according to the module plugged in.
# 
#   Reviewed-by: Florian Fainelli
#   Signed-off-by: Russell King
# 
#   df21c0a8a41080beec0f6d25412b0cbbce482e68
#    drivers/net/phy/phylink.c | 82 +++++++++++++++++++++++++++++++++++++++++++++++
#    include/linux/phylink.h   |  6 ++++
#    2 files changed, 88 insertions(+)
# 
# Author:    Russell King (Tue 22 Sep 20:52:18 BST 2015)
# Committer: Russell King (Mon  8 Aug 15:58:26 BST 2016)
# 
#   phylink: add phylink infrastructure
# 
#   The link between the ethernet MAC and its PHY has become more complex
#   as the interface evolves.  This is especially true with serdes links,
#   where the part of the PHY is effectively integrated into the MAC.
# 
#   Serdes links can be connected to a variety of devices, including SFF
#   modules soldered down onto the board with the MAC, a SFP cage with
#   a hotpluggable SFP module which may contain a PHY or directly modulate
#   the serdes signals onto optical media with or without a PHY, or even
#   a classical PHY connection.
# 
#   Moreover, the negotiation information on serdes links comes in two
#   varieties - SGMII mode, where the PHY provides its speed/duplex/flow
#   control information to the MAC, and 1000base-X mode where both ends
#   exchange their abilities and each resolve the link capabilities.
# 
#   This means we need a more flexible means to support these arrangements,
#   particularly with the hotpluggable nature of SFP, where the PHY can
#   be attached or detached after the network device has been brought up.
# 
#   Ethtool information can come from multiple sources:
#   - we may have a PHY operating in either SGMII or 1000base-X mode, in
#     which case we take ethtool/mii data directly from the PHY.
#   - we may have a optical SFP module without a PHY, with the MAC
#     operating in 1000base-X mode - the ethtool/mii data needs to come
#     from the MAC.
#   - we may have a copper SFP module with a PHY whic can't be accessed,
#     which means we need to take ethtool/mii data from the MAC.
# 
#   Phylink aims to solve this by providing an intermediary between the
#   MAC and PHY, providing a safe way for PHYs to be hotplugged, and
#   allowing a SFP driver to reconfigure the serdes connection.
# 
#   Phylink also takes over support of fixed link connections, where
#   the speed/duplex/flow control are fixed, but link status may be
#   controlled by a GPIO signal.  By avoiding the fixed-phy implementation,
#   phylink can provide a faster response to link events: fixed-phy has
#   to wait for phylib to operate its state machine, which can take
#   several seconds.  In comparison, phylink takes milliseconds.
# 
#   Signed-off-by: Russell King
# 
#   fe5769ee7e6d7d2988dfad4f6266175246c48e11
#    drivers/net/phy/Kconfig      |  10 +
#    drivers/net/phy/Makefile     |   1 +
#    drivers/net/phy/phy_device.c |   1 +
#    drivers/net/phy/phylink.c    | 804 +++++++++++++++++++++++++++++++++++++++++++
#    include/linux/phy.h          |   2 +
#    include/linux/phylink.h      |  70 ++++
#    6 files changed, 888 insertions(+)
#    create mode 100644 drivers/net/phy/phylink.c
#    create mode 100644 include/linux/phylink.h
# 
# Author:    Russell King (Fri 25 Sep 17:43:52 BST 2015)
# Committer: Russell King (Mon  8 Aug 15:58:26 BST 2016)
# 
#   phy: add I2C mdio bus
# 
#   Add an I2C MDIO bus bridge library, to allow phylib to access PHYs which
#   are connected to an I2C bus instead of the more conventional MDIO bus.
#   Such PHYs can be found in SFP adapters and SFF modules.
# 
#   Since PHYs appear at I2C bus address 0x40..0x5f, and 0x50/0x51 are
#   reserved for SFP EEPROMs/diagnostics, we must not allow the MDIO bus
#   to access these I2C addresses.
# 
#   Signed-off-by: Russell King
# 
#   ac0e4dcfb90ec7667b15606bb169f8e45d46723b
#    drivers/net/phy/Kconfig    |  10 +++++
#    drivers/net/phy/Makefile   |   1 +
#    drivers/net/phy/mdio-i2c.c | 109 +++++++++++++++++++++++++++++++++++++++++++++
#    drivers/net/phy/mdio-i2c.h |  19 ++++++++
#    4 files changed, 139 insertions(+)
#    create mode 100644 drivers/net/phy/mdio-i2c.c
#    create mode 100644 drivers/net/phy/mdio-i2c.h
# 
# Author:    Russell King (Sun 18 Oct 19:51:10 BST 2015)
# Committer: Russell King (Mon  8 Aug 15:58:26 BST 2016)
# 
#   phy: export phy_speed_to_str() for phylink
# 
#   phylink would like to reuse phy_speed_to_str() to convert the speed
#   to a string.  Add a prototype and export this helper function.
# 
#   Reviewed-by: Florian Fainelli
#   Signed-off-by: Russell King
# 
#   e71222fc9b327a9a65b9e3965dfdb92c67d98998
#    drivers/net/phy/phy.c | 3 ++-
#    include/linux/phy.h   | 1 +
#    2 files changed, 3 insertions(+), 1 deletion(-)
# 
# Author:    Russell King (Fri 16 Oct 12:18:41 BST 2015)
# Committer: Russell King (Mon  8 Aug 15:58:26 BST 2016)
# 
#   phy: export phy_start_machine() for phylink
# 
#   phylink will need phy_start_machine exported, so lets export it as a
#   GPL symbol.  Documentation/networking/phy.txt indicates that this
#   should be a PHY API function.
# 
#   Reviewed-by: Florian Fainelli
#   Signed-off-by: Russell King
# 
#   6bac8cde886102ecde4722223f48e2778a3935be
#    drivers/net/phy/phy.c | 1 +
#    1 file changed, 1 insertion(+)
# 
# Author:    Russell King (Fri 18 Sep 14:42:16 BST 2015)
# Committer: Russell King (Mon  8 Aug 15:58:26 BST 2016)
# 
#   phy: provide a hook for link up/link down events
# 
#   Sometimes, we need to do additional work between the PHY coming up and
#   marking the carrier present - for example, we may need to wait for the
#   PHY to MAC link to finish negotiation.  This changes phylib to provide
#   a notification function pointer which avoids the built-in
#   netif_carrier_on() and netif_carrier_off() functions.
# 
#   Standard ->adjust_link functionality is provided by hooking a helper
#   into the new ->phy_link_change method.
# 
#   Reviewed-by: Florian Fainelli
#   Signed-off-by: Russell King
# 
#   a1152a3cbcdadd57be418bac2d05a602c2b7a944
#    drivers/net/phy/phy.c        | 42 ++++++++++++++++++++++--------------------
#    drivers/net/phy/phy_device.c | 14 ++++++++++++++
#    include/linux/phy.h          |  1 +
#    3 files changed, 37 insertions(+), 20 deletions(-)
# 
# Author:    Russell King (Sat  3 Oct 09:13:05 BST 2015)
# Committer: Russell King (Mon  8 Aug 15:10:02 BST 2016)
# 
#   cpuidle: mvebu: indicate failure to enter deeper sleep states
# 
#   The cpuidle ->enter method expects the return value to be the sleep
#   state we entered.  Returning negative numbers or other codes is not
#   permissible since coupled CPU idle was merged.
# 
#   At least some of the mvebu_v7_cpu_suspend() implementations return the
#   value from cpu_suspend(), which returns zero if the CPU vectors back
#   into the kernel via cpu_resume() (the success case), or the non-zero
#   return value of the suspend actor, or one (failure cases).
# 
#   We do not want to be returning the failure case value back to CPU idle
#   as that indicates that we successfully entered one of the deeper idle
#   states.  Always return zero instead, indicating that we slept for the
#   shortest amount of time.
# 
#   Signed-off-by: Russell King
# 
#   a0b75738e32f6d401f16686f8af3565865a3cae0
#    drivers/cpuidle/cpuidle-mvebu-v7.c | 6 +++++-
#    1 file changed, 5 insertions(+), 1 deletion(-)
# 
diff --git a/arch/arm/boot/dts/armada-388-clearfog.dts b/arch/arm/boot/dts/armada-388-clearfog.dts
index 2e0556af6e5e..72cc39bfda52 100644
--- a/arch/arm/boot/dts/armada-388-clearfog.dts
+++ b/arch/arm/boot/dts/armada-388-clearfog.dts
@@ -90,16 +90,12 @@
 			};
 
 			ethernet@34000 {
+				managed = "in-band-status";
 				phy-mode = "sgmii";
 				buffer-manager = <&bm>;
 				bm,pool-long = <3>;
 				bm,pool-short = <1>;
 				status = "okay";
-
-				fixed-link {
-					speed = <1000>;
-					full-duplex;
-				};
 			};
 
 			i2c@11000 {
@@ -183,34 +179,6 @@
 						output-low;
 						line-name = "m.2 devslp";
 					};
-					sfp_los {
-						/* SFP loss of signal */
-						gpio-hog;
-						gpios = <12 GPIO_ACTIVE_HIGH>;
-						input;
-						line-name = "sfp-los";
-					};
-					sfp_tx_fault {
-						/* SFP laser fault */
-						gpio-hog;
-						gpios = <13 GPIO_ACTIVE_HIGH>;
-						input;
-						line-name = "sfp-tx-fault";
-					};
-					sfp_tx_disable {
-						/* SFP transmit disable */
-						gpio-hog;
-						gpios = <14 GPIO_ACTIVE_HIGH>;
-						output-low;
-						line-name = "sfp-tx-disable";
-					};
-					sfp_mod_def0 {
-						/* SFP module present */
-						gpio-hog;
-						gpios = <15 GPIO_ACTIVE_LOW>;
-						input;
-						line-name = "sfp-mod-def0";
-					};
 				};
 
 				/* The MCP3021 is 100kHz clock only */
@@ -374,6 +342,16 @@
 		};
 	};
 
+	sfp: sfp {
+		compatible = "sff,sfp";
+		i2c-bus = <&i2c1>;
+		los-gpio = <&expander0 12 GPIO_ACTIVE_HIGH>;
+		moddef0-gpio = <&expander0 15 GPIO_ACTIVE_LOW>;
+		sfp,ethernet = <&eth2>;
+		tx-disable-gpio = <&expander0 14 GPIO_ACTIVE_HIGH>;
+		tx-fault-gpio = <&expander0 13 GPIO_ACTIVE_HIGH>;
+	};
+
 	dsa@0 {
 		compatible = "marvell,dsa";
 		dsa,ethernet = <&eth1>;
@@ -390,12 +368,12 @@
 
 			port@0 {
 				reg = <0>;
-				label = "lan1";
+				label = "lan5";
 			};
 
 			port@1 {
 				reg = <1>;
-				label = "lan2";
+				label = "lan4";
 			};
 
 			port@2 {
@@ -405,12 +383,12 @@
 
 			port@3 {
 				reg = <3>;
-				label = "lan4";
+				label = "lan2";
 			};
 
 			port@4 {
 				reg = <4>;
-				label = "lan5";
+				label = "lan1";
 			};
 
 			port@5 {
@@ -444,3 +422,53 @@
 		};
 	};
 };
+/*
++#define A38x_CUSTOMER_BOARD_1_MPP16_23         0x00400011
+MPP18: gpio		? (pca9655 int?)
+MPP19: gpio		? (clkreq?)
+MPP20: gpio		? (sd0 detect)
+MPP21: sd0:cmd		x sd0
+MPP22: gpio		x mikro int
+MPP23: gpio		x switch irq
++#define A38x_CUSTOMER_BOARD_1_MPP24_31         0x22043333
+MPP24: ua1:rxd		x mikro rx
+MPP25: ua1:txd		x mikro tx
+MPP26: i2c1:sck		x mikro sck
+MPP27: i2c1:sda		x mikro sda
+MPP28: sd0:clk		x sd0
+MPP29: gpio		x mikro rst
+MPP30: ge1:txd2		? (config)
+MPP31: ge1:txd3		? (config)
++#define A38x_CUSTOMER_BOARD_1_MPP32_39         0x44400002
+MPP32: ge1:txctl	? (unused)
+MPP33: gpio		? (pic_com0)
+MPP34: gpio		x rear button (pic_com1)
+MPP35: gpio		? (pic_com2)
+MPP36: gpio		? (unused)
+MPP37: sd0:d3		x sd0
+MPP38: sd0:d0		x sd0
+MPP39: sd0:d1		x sd0
++#define A38x_CUSTOMER_BOARD_1_MPP40_47         0x41144004
+MPP40: sd0:d2		x sd0
+MPP41: gpio		x switch reset
+MPP42: gpio		? sw1-1
+MPP43: spi1:cs2		x mikro cs
+MPP44: sata3:prsnt	? (unused)
+MPP45: ref:clk_out0	?
+MPP46: ref:clk_out1	x switch clk
+MPP47: 4		? (unused)
++#define A38x_CUSTOMER_BOARD_1_MPP48_55         0x40333333
+MPP48: tdm:pclk
+MPP49: tdm:fsync
+MPP50: tdm:drx
+MPP51: tdm:dtx
+MPP52: tdm:int
+MPP53: tdm:rst
+MPP54: gpio		? (pwm)
+MPP55: spi1:cs1		x slic
++#define A38x_CUSTOMER_BOARD_1_MPP56_63         0x00004444
+MPP56: spi1:mosi	x mikro mosi
+MPP57: spi1:sck		x mikro sck
+MPP58: spi1:miso	x mikro miso
+MPP59: spi1:cs0		x w25q32
+*/
diff --git a/drivers/cpuidle/cpuidle-mvebu-v7.c b/drivers/cpuidle/cpuidle-mvebu-v7.c
index 01a856971f05..18ded9e7cb34 100644
--- a/drivers/cpuidle/cpuidle-mvebu-v7.c
+++ b/drivers/cpuidle/cpuidle-mvebu-v7.c
@@ -39,8 +39,12 @@ static int mvebu_v7_enter_idle(struct cpuidle_device *dev,
 	ret = mvebu_v7_cpu_suspend(deepidle);
 	cpu_pm_exit();
 
+	/*
+	 * If we failed to enter the desired state, indicate that we
+	 * slept lightly.
+	 */
 	if (ret)
-		return ret;
+		return 0;
 
 	return index;
 }
diff --git a/drivers/net/ethernet/marvell/Kconfig b/drivers/net/ethernet/marvell/Kconfig
index 2664827ddecd..423124d4d56f 100644
--- a/drivers/net/ethernet/marvell/Kconfig
+++ b/drivers/net/ethernet/marvell/Kconfig
@@ -57,7 +57,7 @@ config MVNETA
 	tristate "Marvell Armada 370/38x/XP network interface support"
 	depends on PLAT_ORION
 	select MVMDIO
-	select FIXED_PHY
+	select PHYLINK
 	---help---
 	  This driver supports the network interface units in the
 	  Marvell ARMADA XP, ARMADA 370 and ARMADA 38x SoC family.
